﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            this.BindData();
        }
    }

    private void BindData()
    {
        string query = "SELECT TOP 10 OrderId, ShipCity, Shippers.ShipperId, Shippers.CompanyName, Customers.ContactName FROM Orders";
        query += " INNER JOIN Shippers ON Orders.ShipVia = Shippers.ShipperId";
        query += " INNER JOIN Customers ON Orders.CustomerId = Customers.CustomerId";
        query += " ORDER BY ShippedDate DESC";
        SqlCommand cmd = new SqlCommand(query);
        gvOrders.DataSource = GetData(cmd);
        gvOrders.DataBind(); 
    }

    private DataTable GetData(SqlCommand cmd)
    {
        string strConnString = ConfigurationManager.ConnectionStrings["conString"].ConnectionString;
        using (SqlConnection con = new SqlConnection(strConnString))
        {
            using (SqlDataAdapter sda = new SqlDataAdapter())
            {
                cmd.Connection = con;
                sda.SelectCommand = cmd;
                using (DataTable dt = new DataTable())
                {
                    sda.Fill(dt);
                    return dt;
                }
            }
        }
    }

    protected void EditCustomer(object sender, GridViewEditEventArgs e)
    {
        gvOrders.EditIndex = e.NewEditIndex;
        this.BindData();
    }

    protected void CancelEdit(object sender, GridViewCancelEditEventArgs e)
    {
        gvOrders.EditIndex = -1;
        BindData();
    }

    protected void RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow && gvOrders.EditIndex == e.Row.RowIndex)
        {
            RadioButtonList rblShippers = (RadioButtonList)e.Row.FindControl("rblShippers");
            string query = "SELECT * FROM Shippers";
            SqlCommand cmd = new SqlCommand(query);
            rblShippers.DataSource = GetData(cmd);
            rblShippers.DataTextField = "CompanyName";
            rblShippers.DataValueField = "ShipperId";
            rblShippers.DataBind();
            rblShippers.Items.FindByValue((e.Row.FindControl("lblShipper") as Label).Text).Selected = true;
        }
    }

    protected void UpdateCustomer(object sender, GridViewUpdateEventArgs e)
    {
        string shipperId = (gvOrders.Rows[e.RowIndex].FindControl("rblShippers") as RadioButtonList).SelectedItem.Value;
        string orderId = gvOrders.DataKeys[e.RowIndex].Value.ToString();
        string strConnString = ConfigurationManager.ConnectionStrings["conString"].ConnectionString;
        using (SqlConnection con = new SqlConnection(strConnString))
        {
            string query = "UPDATE Orders SET Shipvia = @ShipperId WHERE OrderId = @OrderId";
            using (SqlCommand cmd = new SqlCommand(query))
            {
                cmd.Connection = con;
                cmd.Parameters.AddWithValue("@OrderId", orderId);
                cmd.Parameters.AddWithValue("@ShipperId", shipperId);
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
                Response.Redirect(Request.Url.AbsoluteUri);
            }
        }
    }
}