﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindData()
        End If
    End Sub

    Private Sub BindData()
        Dim query As String = "SELECT top 10 OrderId, ShipCity, Shippers.ShipperId, Shippers.CompanyName, Customers.ContactName FROM Orders"
        query += " INNER JOIN Shippers ON Orders.ShipVia = Shippers.ShipperId"
        query += " INNER JOIN Customers ON Orders.CustomerId = Customers.CustomerId"
        query += " ORDER BY ShippedDate DESC"
        Dim cmd As New SqlCommand(query)
        gvOrders.DataSource = GetData(cmd)
        gvOrders.DataBind()
    End Sub

    Private Function GetData(cmd As SqlCommand) As DataTable
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As New SqlConnection(strConnString)
            Using sda As New SqlDataAdapter()
                cmd.Connection = con
                sda.SelectCommand = cmd
                Using dt As New DataTable()
                    sda.Fill(dt)
                    Return dt
                End Using
            End Using
        End Using
    End Function

    Protected Sub EditCustomer(sender As Object, e As GridViewEditEventArgs)
        gvOrders.EditIndex = e.NewEditIndex
        Me.BindData()
    End Sub

    Protected Sub CancelEdit(sender As Object, e As GridViewCancelEditEventArgs)
        gvOrders.EditIndex = -1
        BindData()
    End Sub

    Protected Sub RowDataBound(sender As Object, e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow AndAlso gvOrders.EditIndex = e.Row.RowIndex Then
            Dim rblShippers As RadioButtonList = DirectCast(e.Row.FindControl("rblShippers"), RadioButtonList)
            Dim query As String = "SELECT * FROM Shippers"
            Dim cmd As New SqlCommand(query)
            rblShippers.DataSource = GetData(cmd)
            rblShippers.DataTextField = "CompanyName"
            rblShippers.DataValueField = "ShipperId"
            rblShippers.DataBind()
            rblShippers.Items.FindByValue(TryCast(e.Row.FindControl("lblShipper"), Label).Text).Selected = True
        End If
    End Sub

    Protected Sub UpdateCustomer(sender As Object, e As GridViewUpdateEventArgs)
        Dim shipperId As String = TryCast(gvOrders.Rows(e.RowIndex).FindControl("rblShippers"), RadioButtonList).SelectedItem.Value
        Dim orderId As String = gvOrders.DataKeys(e.RowIndex).Value.ToString()
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As New SqlConnection(strConnString)
            Dim query As String = "UPDATE Orders SET Shipvia = @ShipperId WHERE OrderId = @OrderId"
            Using cmd As New SqlCommand(query)
                cmd.Connection = con
                cmd.Parameters.AddWithValue("@OrderId", orderId)
                cmd.Parameters.AddWithValue("@ShipperId", shipperId)
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
                Response.Redirect(Request.Url.AbsoluteUri)
            End Using
        End Using
    End Sub
End Class



